import newGameLib
reload(newGameLib)
from newGameLib import *
import Blender
	
import math
from math import *


class Model:
	def __init__(self):
		self.meshList=[]
		
	
def xacParser(filename,g):
	skeleton=Skeleton()
	skeleton.BONESPACE=True
	skeleton.NICE=True

	
	g.word(4) 
	g.B(4) 
	
	modelList=[]
	matList=[]
	
	
	while(True):
			data = g.i(3)
			back = g.tell()
			if data[0]==8:
				g.seek(16,1)
				break
			elif data[0]==7:
				g.i(2);g.B(4);g.i(1)[0]
				g.word(g.i(1)[0])
				modelName=g.word(g.i(1)[0])
				g.word(g.i(1)[0])
				g.i(1)[0]
			elif data[0]==11:
				boneCount=g.i(1)[0]
				g.i(1)
				for m in range(boneCount):
					bone=Bone()
					t=g.tell()
					bone.rotMatrix=QuatMatrix(g.f(4)).resize4x4()
					g.seek(16,1)
					bone.posMatrix=VectorMatrix(g.f(4))
					g.seek(t+68)
					w=g.i(4)
					bone.parentID=w[2]
					g.seek(t+156)
					bone.name=g.word(g.i(1)[0])[-25:]
					skeleton.boneList.append(bone)
			elif data[0]==0:
				w = g.f(16)
				v = g.i(4)
				name = g.word(g.i(1)[0])[-25:]
			elif data[0]==3:
				print
				mat=Mat()
				g.f(21)
				g.word(g.i(1)[0])
				unk=g.f(1)[0]
				texID=0
				while 0.1<unk<=1:
					g.seek(24,1)
					imageName=g.word(g.i(1)[0])+'.dds'
					print imageName
					unk=g.f(1)[0]
					if texID==0:mat.diffuse=g.dirname+os.sep+imageName
					if texID==1:mat.specular=g.dirname+os.sep+imageName
					texID+=1
				else:
					g.seek(-4,1)
				matList.append(mat)	
					
			elif data[0]==4:
				g.f(7)
				imageName = g.word(g.i(1)[0])
			elif data[0]==1:
				model=Model()
				meshList=[]
				skinList=[]				
				vertPosList=[]
				vertUVList=[]
				skinIDList=[]
				model.skinIndiceList=[]
				model.skinWeightList=[]	
				w = g.i(7) 				
				model.ID=w[0]
				model.skinVertCount=w[1]				
				vertexCount = w[2]
				faceCount = w[3] 
				meshCount = w[4]
				for m1 in range(w[5]):
					v = g.i(3)	
					if v[0]==0:#position 
						for m in range(vertexCount):vertPosList.append(g.f(3))
					elif v[0]==1:#normals 
						for m in range(vertexCount):g.f(3) 
					elif v[0]==3:#uv
						for m in range(vertexCount):vertUVList.append(g.f(2))
					elif v[0]==2:
						for m in range(vertexCount):g.f(4)
					elif v[0]==5:
						for m in range(vertexCount):skinIDList.append(g.i(1)[0])		
					else:print 'unknow',v	
				vertIDStart=0		
				for i in range(meshCount):
					mesh=Mesh()
					w = g.i(4)	
					mesh.indiceList=g.i(w[0])
					mesh.vertPosList=vertPosList[vertIDStart:vertIDStart+w[1]]
					mesh.vertUVList=vertUVList[vertIDStart:vertIDStart+w[1]]
					mesh.skinVertIDList=skinIDList[vertIDStart:vertIDStart+w[1]]
					mesh.vertIDStart=vertIDStart
					mesh.ID=w[0]
					boneMap=g.i(w[3]) 
					mat=matList[w[2]]
					mat.TRIANGLE=True
					mat.ZTRANS=True
					mesh.matList.append(mat)
					vertIDStart+=w[1]
					model.meshList.append(mesh)
				modelList.append(model)	
					
			elif data[0]==2:
				w = g.i(4)	
				t=g.tell()
				g.seek(w[2]*8,1)
				for model in modelList:
					if model.ID==w[0]:
						model.listA=[]
						for i in range(model.skinVertCount):
							model.listA.append(g.i(2))
						tt=g.tell()	
						g.seek(t)
						for i in range(model.skinVertCount):
							indiceList=[]
							weightList=[]
							for j in range(model.listA[i][1]):
								weightList.append(g.f(1)[0])
								indiceList.append(g.i(1)[0])							
							model.skinIndiceList.append(indiceList)
							model.skinWeightList.append(weightList)
						g.seek(tt)
			else:g.seek(data[1],1) 
			if g.tell()==g.fileSize():
				break 
	skeleton.draw()	
	for model in modelList:
		for mesh in model.meshList:
			if len(model.skinIndiceList)>0:
				for id in mesh.skinVertIDList:
					mesh.skinIndiceList.append(model.skinIndiceList[id])
					mesh.skinWeightList.append(model.skinWeightList[id])
				skin=Skin()	
				skin.boneMap=skeleton.boneNameList
				mesh.skinList.append(skin)
				mesh.BINDSKELETON=skeleton.name	
				mesh.draw()  
	print g.tell()
	
	
	
def xsmParser(filename,g):
	g.word(4)   
	g.H(16)
	g.word(g.i(1)[0])
	g.word(g.i(1)[0])
	g.word(g.i(1)[0])
	g.i(1)
	num = 0
	
	action=Action()
	action.name=g.basename
	action.BONESPACE=True
	#action.ARMATURESPACE=True
	action.BONESORT=True
	
	while(True):
		data = g.i(3)
		back = g.tell()
		if data[0]==202:
			bones_count=g.i(1)[0]
			for m in range(bones_count):
				t=g.tell()
				g.f(20)
				data1=g.i(4)
				g.seek(t+100)
				name=g.word(g.i(1)[0])
				abone=ActionBone()
				abone.name=name
				
				for i in range(data1[0]):	 
					loc = g.f(3)
					posmatrix=VectorMatrix(loc)
					abone.posKeyList.append(posmatrix)
					time =  int(g.f(1)[0]*30)
					abone.posFrameList.append(time)
				for i in range(data1[1]):
					rotmatrix=QuatMatrix(g.short(4,'h',15)).resize4x4()	
					abone.rotKeyList.append(rotmatrix)
					time =  int(g.f(1)[0]*30)					
					abone.rotFrameList.append(time)	
					
				for i in range(data1[2]):
					g.f(3),round(g.f(1)[0]*30,0)
				for i in range(data1[3]):
					g.h(4),round(g.f(1)[0]*30,0)
				action.boneList.append(abone)
		if g.tell()==g.fileSize():break 
		
		
		
		
		
	action.draw() 
	action.setContext()	
	g.tell()	
	
	
	
	
	
def Parser():	
	filename=input.filename
	print
	print filename
	print 
	imageList=input.imageList
	ext=filename.split('.')[-1].lower()	
	
	if ext=='msh':
		file=open(filename,'rb')
		g=BinaryReader(file)
		mshParser(filename,g)
		file.close()
	
	if ext=='xac':
		file=open(filename,'rb')
		g=BinaryReader(file)
		xacParser(filename,g)
		file.close()
	
	if ext=='xsm':
		file=open(filename,'rb')
		g=BinaryReader(file)
		xsmParser(filename,g)
		file.close()
 
def openFile(flagList):
	global input,output
	input=Input(flagList)
	output=Output(flagList)
	parser=Parser()
	
Blender.Window.FileSelector(openFile,'import','DKOnline files *.xac, *.xsm')